#!/bin/sh
#
EXT=mariadb-10.1
TCZROOT=/mnt/sda1/lamp/test/temp/$EXT

sudo rm -rf $TCZROOT/*

TCZ=$TCZROOT/TCZ

for a in compiletc perl5 cmake readline-dev openssl-dev pcre-dev \
		liblzma-dev libaio-dev jemalloc-dev libxml2-dev \
		cracklib-dev cracklib msgpack-dev msgpack linux-pam-dev \
		libevent-dev libevent openldap-dev openldap unixODBC-dev unixODBC \
		squashfs-tools bash
	do tce-load -i $a
done

for a in ../mariadb-patches//*
	do patch -Np1 -i $a
done

chmod a+x ./storage/tokudb/PerconaFT/third_party/xz-4.999.9beta/build-aux/install-sh
chmod a+x ./storage/tokudb/PerconaFT/third_party/snappy-1.1.2/install-sh

export CC="gcc -mtune=generic -Os -pipe"
export CXX="g++ -mtune=generic -Os -pipe"

cmake . -LH \
	-DCMAKE_BUILD_TYPE=MinSizeRel \
	-DFEATURE_SET=xsmall \
	-DMRN_GROONGA_EMBED=OFF \
	-DWITH_SSL=system \
	-DWITH_ZLIB=system \
	-DWITH_PCRE=system \
	-DWITH_READLINE=no \
	-DWITH_EMBEDDED_SERVER=OFF \
	-DMYSQL_MAINTAINER_MODE=OFF \
	-DWITH_SYSTEMD=no \
	-DMYSQL_DATADIR=/home/tc/mysql/data \
	|| exit

make || exit
make test || exit 
make install DESTDIR=$TCZ
for a in $(find $TCZ -type f); do file -b $a | grep -q '^ELF .*not stripped$' && strip $a; done

mkdir -p $TCZ-doc/usr/local/mysql
mkdir -p $TCZ-test/usr/local/mysql
mkdir -p $TCZ-dev/usr/local/mysql/bin
mkdir -p $TCZ-dev/usr/local/mysql/lib
mkdir -p $TCZ-dev/usr/local/mysql/share

mv $TCZ/usr/local/mysql/docs $TCZ-doc/usr/local/mysql
mv $TCZ/usr/local/mysql/man $TCZ-doc/usr/local/mysql

mv $TCZ/usr/local/mysql/mysql-test $TCZ-test/usr/local/mysql
mv $TCZ/usr/local/mysql/sql-bench $TCZ-test/usr/local/mysql

mv $TCZ/usr/local/mysql/include $TCZ-dev/usr/local/mysql
mv $TCZ/usr/local/mysql/bin/mysql_config $TCZ-dev/usr/local/mysql/bin
mv $TCZ/usr/local/mysql/lib/pkgconfig $TCZ-dev/usr/local/mysql/lib
mv $TCZ/usr/local/mysql/share/pkgconfig $TCZ-dev/usr/local/mysql/share
mv $TCZ/usr/local/mysql/share/aclocal $TCZ-dev/usr/local/mysql/share
for a in $(find $TCZ -name '*.a'); do
        b=$(echo $(dirname $a) | sed "s#$TCZ#$TCZ-dev#")
        mkdir -p $b
        mv $a $b
done
for a in $(find $TCZ -name '*.la'); do
        b=$(echo $(dirname $a) | sed "s#$TCZ#$TCZ-dev#")
        mkdir -p $b
        mv $a $b
done

sudo chown -R root.root $TCZ*

mksquashfs $TCZ $TCZROOT/$EXT.tcz -noappend
mksquashfs $TCZ-dev $TCZROOT/$EXT-dev.tcz -noappend
mksquashfs $TCZ-doc $TCZROOT/$EXT-doc.tcz -noappend
mksquashfs $TCZ-test $TCZROOT/$EXT-test.tcz -noappend

